<?php
/**
* @package Shared_lib
*
* A collection of useful functions for use in PHP projects
*
* files.php contains functions relating to file manipulation/alterations
*
* @copyright Copyright (C) 2011 B Tasker
* @license  GPLV3, see LICENSE
*/



/**
* Move or copy a file on the server
*
* @param string file - Path to the original file
* @param string newfile - Path to copy/move to (inc filename)
* @param string action - Action to take, (C)opy or (M)ove (default Copy)
*
* @return True if action completed successfully
*/
function movecopy_file($file,$newfile,$action)
{
if ($action == "M"){

if (!rename("$file","$newfile"))
	    {
    return 0;
	    }
else
	    {
    return 1;
	    }

      }
else
      {

if (!copy("$file","$newfile"))
		{
	return 0;
		}
else
		{
	return 1;
		}
	   }
}


?>