<?php
/**
* This file is part of the BUGGER Library 
*
* Copyright (C) 2011 B Tasker
* License: GPLV3, see LICENSE
*/

include_once 'lib/auth.php';
include_once 'lib/db/retrieve.php';
include_once 'lib/db/db_basics.php';
include_once 'lib/db/insert.php';

// Include the shared lib
include_once 'lib/Shared_lib/shared_lib.php';

// Include the PEAR mail and Mime headers

include_once 'lib/PEAR/MIME/mime.php';
include_once 'lib/PEAR/Mail/Mail.php';



/*
// mime_content_type has been depreceated.
if ( ! function_exists ( 'mime_content_type ' ) )
{
   function mime_content_type ( $f )
   {
       return trim ( exec ('file -bi ' . escapeshellarg ( $f ) ) ) ;
   }
}
*/

function generate_display_settings_form()
{
$privset = check_user_priviliges_access("A");

if ($privset == 1)
{


$result = db_retrieve_config();
while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{


echo "<form method=\"post\" action=\"admin.php\">\n" .
"<table><tbody>\n" .
"<tr><td class=\"tblhead\">Display Bugs:</td><td><input type=\"checkbox\" name=\"DisplayBugs\" value=\"1\" ";

if ($row['DisplayBugs'] == 1)
{
echo "checked ";

}
echo " /></td></tr>\n" .
"<tr><td class=\"tblhead\">Display Documents:</td><td><input type=\"checkbox\" name=\"DisplayDocuments\" value=\"1\" ";

if ($row['DisplayDocuments'] == 1)
{
echo "checked ";
}

echo " /></td></tr>\n" .
"<tr><td class=\"tblhead\">Display Releases:</td><td><input type=\"checkbox\" name=\"DisplayReleases\" value=\"1\" ";

if ($row['DisplayReleases'] == 1)
{
echo "checked ";

}

echo " /></td></tr>\n" .

"<tr><td class=\"tblhead\">Display Changelog:</td><td><input type=\"checkbox\" name=\"DisplayChangelog\" value=\"1\" ";
if ($row['DisplayChangelog'] == 1)
{
echo "checked ";

}

echo " /></td></tr>\n" .


"<tr><td class=\"tblhead\">Display Tasks:</td><td><input type=\"checkbox\" name=\"DisplayTasks\" value=\"1\" ";
if ($row['DisplayTasks'] == 1)
{
echo "checked ";

}

echo " /></td></tr>\n" .



"<tr><td class=\"tblhead\"><input type=\"hidden\" name=\"action\" value=\"processdispconf\"></td><td><input type=\"submit\" value=\"Save\" /></td></tr>\n" .
"</tbody></table>\n</form>\n\n\n";

}

}

}


function process_display_settings_form()
{
// Should be data in POST



$privset = check_user_priviliges_access("A");

if ($privset == 1)
{

$newdata['DisplayBugs'] = $_POST['DisplayBugs'];
$newdata['DisplayDocuments'] = $_POST['DisplayDocuments'];
$newdata['DisplayReleases'] = $_POST['DisplayReleases'];
$newdata['DisplayChangelog'] = $_POST['DisplayChangelog'];
$newdata['DisplayTasks'] = $_POST['DisplayTasks'];

$result = insert_display_settings($newdata);

if ($result == 1)
{
echo "Saved! <br /><br />";

}
else
{
echo "An error occurred";

}

}
}


function display_backuppass_form()
{
$privset = check_user_priviliges_access("A");

if ($privset == 1)
{


if ($_GET['stat'] == "1")
{
echo "Saved! <br /><br />";
$genform = "No";
}

if ($_GET['stat'] == "2")
{
echo "An Error Occurred <br /><br />";
}

if ($genform != "No")
{

// Generate a new password
$genpasswd = generate_salt();

// Add a record to the authtokens table
$idkey = mt_rand(100,999999999999);
$curruser = get_current_user_name();
db_insert_auth_token($curruser,$idkey,"","backuppass");


include 'config/config.php';
echo "Make sure you write the password down as it won't be displayed again!, You can use the suggested password or type your own" .
"<form method=\"post\" action=\"$cryptoconnection/adminbackupproc.php\">\n" .
"<table><tbody>\n" .
"<tr><td class=\"tblhead\">Password:</td><td>" .
"<input type=\"text\" name=\"Pass\" value=\"$genpasswd\">\n<input type=\"hidden\" name=\"user\" value=\"$curruser\"></td></tr>\n" .
"<tr><td><input type=\"hidden\" name=\"key\" value=\"$idkey\"><input type=\"hidden\" name=\"action\" value=\"backuppassprocess\"></td>" .
"<td><input type=\"submit\" value=\"save\"></form></td></tr>\n" .
"</table></form>";
}

}
}




function process_backuppass_form()
{

// User details may not be in session at this point, so use the Idkey to identify and authenticate

$idkey = $_POST['key'];
$username = $_POST['user'];

$results = db_validate_user_auth_token($idkey,$username,"backuppass");

if ($results['auth'] == 1)
{
// Set our Session vars for the benefit of the interested functions

$_SESSION['loggedin'] = 1;
$_SESSION['User'] = $results['UserName'];

}

$privset = check_user_priviliges_access("A");

if ($privset == 1)
  {
// Should be data in POST


$newdata['BackupSalt1'] = generate_salt();
$newdata['BackupSalt2'] = generate_salt();

$newdata['BackupPass'] = salt_pass($_POST['Pass'],$newdata['BackupSalt1'],$newdata['BackupSalt2']);





$result = insert_backup_settings($newdata);
include 'config/config.php';
if ($result == 1)
{
header("Location: $plainconnection/admin.php?action=backuppass&stat=1");

}
else
{
header("Location: $plainconnection/admin.php?action=backuppass&stat=2");

}


}


}



function db_backup_download($DownloadFile)
{

// Run the backup and get the file location
$outputfile = backup_db();

// Grab system config
include 'config/config.php';


// Send the file for download if requested

if ($DownloadFile == "Y"){

// Calculate the filesize for the headers
$FileSize = filesize($outputfile);
$MIMEType = mime_content_type($outputfile);


// Seperate the path
$path_info = pathinfo($outputfile);

// Send Headers
header("Content-length: $FileSize");
header("Content-type: $MIMEType");
header("Content-Disposition: attachment; filename={$path_info['basename']}");


// Convert filesize to KB so that fread doesn't bum out
$freadbytes = round($FileSize / 1024);

if ($fd = fopen ($outputfile, "r")){


// Output the file
 while(!feof($fd)) {
        $buffer = fread($fd,$freadbytes);
        echo $buffer;
    }
 
}
 
}





// Send our email

if ($emailbackup == "Y"){

//$success = mail_to($emailfrom,$backupto,$subject,$outputfile,$MIMEType,)


$headers = array('From' => $emailfrom, 'Subject' => $subject);
$textMessage = $outputfile;
$htmlMessage = "";

$mime = new Mail_Mime("\n");
$mime->setTxtBody($textMessage);
$mime->setHtmlBody($htmlMessage);
$mime->addAttachment($outputfile, $MIMEType);
$body = $mime->get();
$hdrs = $mime->headers($headers);
$mail = &Mail::factory('mail');
$mail->send($backupto, $hdrs, $body);

}





// Delete the files
unlink($outputfile);





}











/*
Currently takes too long to run



function backup_tables($DownloadFile, $tables = '*')
{
 // Shamelessly pulled from http://davidwalsh.name/backup-mysql-database-php
// Adapted to suit

include 'config/config.php';
 
  $link = mysql_connect($dbhost,$dbuser,$dbpass);
  mysql_select_db($dbname,$link);
  
  //get all of the tables
  if($tables == '*')
  {
    $tables = array();
    $result = mysql_query('SHOW TABLES');
    while($row = mysql_fetch_row($result))
    {
      $tables[] = $row[0];
    }
  }
  else
  {
    $tables = is_array($tables) ? $tables : explode(',',$tables);
  }
  
  //cycle through
  foreach($tables as $table)
  {
    $result = mysql_query('SELECT * FROM '.$table);
    $num_fields = mysql_num_fields($result);
    
    $return.= 'DROP TABLE '.$table.';';
    $row2 = mysql_fetch_row(mysql_query('SHOW CREATE TABLE '.$table));
    $return.= "\n\n".$row2[1].";\n\n";
    
    for ($i = 0; $i < $num_fields; $i++) 
    {
      while($row = mysql_fetch_row($result))
      {
        $return.= 'INSERT INTO '.$table.' VALUES(';
        for($j=0; $j<$num_fields; $j++) 
        {
          $row[$j] = addslashes($row[$j]);
          $row[$j] = ereg_replace("\n","\\n",$row[$j]);
          if (isset($row[$j])) { $return.= '"'.$row[$j].'"' ; } else { $return.= '""'; }
          if ($j<($num_fields-1)) { $return.= ','; }
        }
        $return.= ");\n";
      }
    }
    $return.="\n\n\n";
  }
  


// Filenaming conventions
$sqlFile = $tmpdir."/".$prefix.date('Y_m_d').".sql";
$attachment = $tmpdir."/".$prefix.date('Y_m_d').".tgz";

  //save file
  $handle = fopen($sqlFile,'w+');
  fwrite($handle,$return);
  fclose($handle);


$outputfile = $sqlFile;

if ($backupcompress == "Y"){

// Zip it
$createZip = "tar cvzf $attachment $sqlFile";
exec($createZip);
$outputfile = $attachment;

  }


// Send the file for download if requested

if ($DownloadFile == "Y"){

// Calculate the filesize for the headers
$FileSize = filesize($outputfile);
$MIMEType = mime_content_type($outputfile);


// Seperate the path
$path_info = pathinfo($outputfile);

// Send Headers
header("Content-length: $FileSize");
header("Content-type: $MIMEType");
header("Content-Disposition: attachment; filename={$path_info['basename']}");


// Convert filesize to KB so that fread doesn't bum out
$freadbytes = round($FileSize / 1024);

if ($fd = fopen ($outputfile, "r")){


// Output the file
 while(!feof($fd)) {
        $buffer = fread($fd,$freadbytes);
        echo $buffer;
    }
 
}
 
}





// Send our email

if ($emailbackup == "Y"){

$headers = array('From' => $emailfrom, 'Subject' => $subject);
$textMessage = $attachment;
$htmlMessage = "";

$mime = new Mail_Mime("\n");
$mime->setTxtBody($textMessage);
$mime->setHtmlBody($htmlMessage);
$mime->addAttachment($attachment, $MIMEType);
$body = $mime->get();
$hdrs = $mime->headers($headers);
$mail = &Mail::factory('mail');
$mail->send($backupto, $hdrs, $body);

}





// Delete the files
unlink($sqlFile);

// Do we need to remove the attachment
if ($backupcompress == "Y")
{
unlink($attachment);
}






}




*/










?>
