<?php
/**
* This file is part of the BUGGER Library 
*
* Copyright (C) 2011 B Tasker
* License: GPLV3, see LICENSE
*/

include_once 'lib/db/retrieve.php';
include_once 'lib/db/insert.php';
include_once 'lib/db/db_basics.php';
include_once 'lib/Shared_lib/shared_lib.php';

function get_current_user_name()
{

return $_SESSION['User'];


}

function get_remote_host()
{
return $_SERVER['REMOTE_ADDR'];

}



function check_backup_privileges($pass)
{

$result = db_retrieve_backup_pass();

open_db();
$newpass = make_string_safe($pass);
close_db();


$newpass = salt_pass($newpass,$result['BackupSalt1'],$result['BackupSalt2']);

if ($newpass == $result['BackupPass'])
{
return 1;
}
else
{
return 0;
}


}



function get_user_displayname($user)
{
$result = db_retrieve_user_info($user);

$row = mysql_fetch_array($result, MYSQL_ASSOC);

return $row['DisplayName'];

}






function check_user_privileges_file($privset)
{

// If unrestricted, OK it
if ($privset == "U")
{
return 1;
}


$username = get_current_user_name();


if ($privset == "R")
{

if (!empty($username))
{
return 1;
}
else
{
return 0;
}
}


open_db();
$result = db_retrieve_user_info($username);

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

if (($privset == "D") && ($row['Developer'] == 1))
{
return 1;
}

if (($privset == "A") && ($row['Admin'] == 1))
{
return 1;
}


}

return 0;

}




function retrieve_user_salt($username)
{
$result = db_retrieve_user_salt($username);
while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{
$salt['S1'] = $row['S1'];
$salt['S2'] = $row['S2'];
return $salt;
}
}





function process_login()
{
// User's tried to login

$creds['Username'] = $_POST['User'];

$salt = retrieve_user_salt($creds['Username']);

$creds['Pass'] = salt_pass($_POST['Pass'],$salt['S1'],$salt['S2']);

// Retrieve the users auth details
$result = db_retrieve_user_login_dets($creds['Username']);

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

if (($creds['Username'] == $row['UserName']) && ($creds['Pass'] == $row['Password']))
{
include 'config/config.php';

// some webhosts use a shared SSL cert on a different URL. Session cookie will be set for the wrong site if we set it here.
// Generate an authentication token and pass the info across

$idkey = mt_rand(999,99999999999999);

db_insert_auth_token($row['UserName'],$idkey,$row['DisplayName'],"login");

header("Location: $plainconnection/login2.php?action=proc&key=$idkey&user={$row['UserName']}");

echo "<html>\n<head><title>Login successful</title></head>\n\n<body>" .
"Click <a href=\"$plainconnection/login2.php?action=proc&key=$idkey&user={$row['UserName']}\">here</a> if you" .
" are not automatically redirected\n\n</body></html>";


}
else
{
echo "Login failed";
}
}


}

function action_login()
{
// validate our info

$idkey = $_GET['key'];
$username = $_GET['user'];
// Compare to our database entries

$results = db_validate_user_auth_token($idkey,$username,"login");

if ($results['auth'] == 1)
{

$_SESSION['loggedin'] = 1;
$_SESSION['Name'] = $results['DisplayName'];
$_SESSION['User'] = $results['UserName'];

echo "Login Successful";

}
else
{
echo "Login failed";
}

}




function check_user_priviliges_access($privset)
{

$username = get_current_user_name();
$result = db_retrieve_user_info($username);

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

/* Privilege settings

NP - Non-Public, Must be Admin or Developer
D - Must be a Developer
A - Must be an Administrator

*/


if ($privset == "NP")
{
if (($row['Admin'] == 1) || ($row['Developer'] == 1))
{
return 1;
}
}

if (($privset == "D") && ($row['Developer'] == 1))
{
return 1;
}

if (($privset == "A") && ($row['Admin'] == 1))
{
return 1;
}

if (($privset == "M") && ($row['Moderator'] == 1))
{
return 1;
}

// User lacks the credentials
return 0;


}

}



?>
