<?php
/**
* This file is part of the BUGGER Library 
*
* Copyright (C) 2011 B Tasker
* License: GPLV3, see LICENSE
*/

include_once 'lib/db/retrieve.php';
include_once 'lib/auth.php';

function output_BBcode_support()
{
echo "<i><font size=\"-1\">Use [bug]bugid[/bug] to automatically link to a bug</i></font>";
}


function list_developer_users($buttontext,$targetpage,$createform,$method,$selected)
{
if ($createform == "Y" )
{

// Process the method type
if ($method == "1")
{
$meth = "POST";
}
else
{
$meth = "GET";

}

// Begin the form
echo "<form action=\"$targetpage\" method=\"$meth\">";
}


// Output the beginnings of the dropdown
echo "<select name=\"Developer\" id=\"Developer\" class=\"selectmenu\">";

$result = db_retrieve_developers();

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{
if ($row['Username'] == $selected)
{
echo "<option value=\"{$row['Username']}\" selected>{$row['DisplayName']}</option>\n";
}
else
{
echo "<option value=\"{$row['Username']}\">{$row['DisplayName']}</option>\n";
}
}

echo "</select>";

if ($createform == 'Y' )
{
echo  "<input type=\"submit\" value=\"$buttontext\"></form>";
}

}


// Generate a list of licenses as a HTML Dropdown menu
function generate_license_dropdown($buttontext,$targetpage,$createform,$method,$selected)
{
if ($createform == "Y" )
{

// Process the method type
if ($method == "1")
{
$meth = "POST";
}
else
{
$meth = "GET";

}

// Begin the form
echo "<form action=\"$targetpage\" method=\"$meth\">";
}


// Output the beginnings of the dropdown
echo "<select name=\"License\" id=\"License\" class=\"selectmenu\">";

// Grab a list of Project Names and ID's
$result = db_retrieve_licenses("N");


while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

echo "<option value=\"{$row['LicenseRef']}\">{$row['LicenseName']}</option>";

}
close_db();
// close the selectmenu
echo "</select>";

if ($createform == 'Y' )
{
echo  "<input type=\"submit\" value=\"$buttontext\"></form>";
}




}

// Generate a list of projects as a HTML Dropdown menu
function generate_project_dropdown($buttontext,$targetpage,$createform,$method,$fieldname = "Project",$onupdate = null,$class = "selectmenu")
{



if ($createform == "Y" )
{

// Process the method type
if ($method == "1")
{
$meth = "POST";
}
else
{
$meth = "GET";

}

// Begin the form
echo "<form action=\"$targetpage\" method=\"$meth\">";
}

if (!empty($onupdate))
{
$onchange = " onchange=\"$onupdate\"";
}


// Output the beginnings of the dropdown
echo "<select name=\"$fieldname\" id=\"$fieldname\" class=\"$class\"$onchange>\n" .
"<option value=\"4\">-- Select a Project</option>\n<option value=\"4\"></option>\n" .
"<option value=\"4\">Active Projects</option>\n<option value=\"4\">-----</option>\n";


$privset = check_user_priviliges_access("NP");

if ($privset == 1)
{
// Grab a list of Project Names and ID's
$result = db_retrieve_projects_nonpublic();
}
else
{
// Grab a list of Project Names and ID's
$result = db_retrieve_projects();
}


// Read the results
while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{
if (!empty($_GET[$fieldname]) && $_GET[$fieldname] == $row['ProjectRef'])
{
$selected = "selected";
}

if ($row['DevelopmentStopped'] == 1 && $X != 1)
{
echo "<option value=\"4\"></option>\n<option value=\"4\">Inactive Projects</option>\n<option value=\"4\">-----</option>\n";
$X = 1;
}

if ($row['Public'] == "0"){

$string = " (nonpublic)";
}


echo "<option value=\"{$row['ProjectRef']}\" $selected>  {$row['ProjectName']}$string</option>";
$string = null;
$selected = null;
}
close_db();
// close the selectmenu
echo "</select>";

if ($createform == 'Y' )
{
echo  "<input type=\"submit\" value=\"$buttontext\"></form>";
}




}


function generate_project_dropdown_JS($buttontext,$targetpage,$createform,$method)
{



if ($createform == "Y" )
{

// Process the method type
if ($method == "1")
{
$meth = "POST";
}
else
{
$meth = "GET";

}

// Begin the form
echo "<form action=\"$targetpage\" method=\"$meth\">";
}


// Output the beginnings of the dropdown
echo "<select name=\"Project\" id=\"Project\" class=\"selectmenu\" OnUpdate=\"submitform();\">";



$privset = check_user_priviliges_access("NP");

if ($privset == 1)
{
// Grab a list of Project Names and ID's
$result = db_retrieve_projects_nonpublic();
}
else
{
// Grab a list of Project Names and ID's
$result = db_retrieve_projects();
}





while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

echo "<option value=\"{$row['ProjectRef']}\">{$row['ProjectName']}</option>";

}
close_db();
// close the selectmenu
echo "</select>";

if ($createform == 'Y' )
{
echo  "<input type=\"submit\" value=\"$buttontext\"></form>";
}




}





// Generate a form to allow the registering of a new release
function register_new_release()
{

echo "<form method=\"post\" enctype=\"multipart/form-data\" action=\"registerfile.php\">
<table width=\"100%\"><tbody>\n" . 
"<td class=\"tblhead\">Project:</td><td class=\"tblcontent\">";

generate_project_dropdown("","","N","");

echo "</td></tr>\n" .
"<tr><td class=\"tblhead\">Version:</td><td class=\"tblcontent\"><input type=\"text\" name=\"Version\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Release Type:</td><Td class=\"tblcontent\"><select name=\"Patch\"><option value=\"0\">Full Release</option>" . 
"<option value=\"1\">Patch Release</option></select></td></tr>\n" .
"<tr><td class=\"tblhead\">Security:</td><td class=\"tblcontent\"><select name=\"Security\"><option value=\"U\">Public</option>" .
"<option value=\"R\">Registered</option><option value=\"D\">Developers</option><option value=\"A\">Administrators</option></select></td></tr>\n" .
"<tr><td class=\"tblhead\">License:</td><td class=\"tblcontent\">";

generate_license_dropdown("","","N","","");

echo "</td></tr>\n" . 
"<tr><td class=\"tblhead\">MD5:</td><td class=\"tblcontent\"><input name=\"MD5\" type=\"text\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Release File:</td><td class=\"tblcontent\"><input type=\"file\" name=\"File\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Notes:</td><td class=\"tblcontent\"><textarea name=\"Notes\"></textarea></td></tr>\n" . 
"<tr><td></td><td><input type=\"hidden\" name=\"type\" value=\"rel\"><input type=\"submit\" value=\"Add Release\"></td></tr>\n" . 
"</tbody></table></form>";


}


// Generate a form to allow the registering of a new document
function register_new_document()
{

echo "<form method=\"post\" enctype=\"multipart/form-data\" action=\"registerfile.php\">
<table width=\"100%\"><tbody>\n" . 
"<td class=\"tblhead\">Project:</td><td class=\"tblcontent\">";

generate_project_dropdown("","","N","");

echo "</td></tr>\n" .
"<tr><td class=\"tblhead\">Document Title:</td><td class=\"tblcontent\"><input type=\"text\" name=\"Doctitle\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Document Version:</td><Td class=\"tblcontent\"><input type=\"text\" name=\"Docversion\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Document Description:</td><td class=\"tblcontent\"><textarea name=\"Docdescription\"></textarea></td></tr>\n" .
"<tr><td class=\"tblhead\">Document Security:</td><td class=\"tblcontent\"><select name=\"DocSec\" id=\"DocSec\"><option value=\"U\">Public</option>" .
"<option value=\"R\">Registered</option><option value=\"D\">Developers</option><option value=\"A\">Administrators</option></select></td></tr>\n" .
"<tr><td class=\"tblhead\">License:</td><td class=\"tblcontent\">";

generate_license_dropdown("","","N","","");

echo "</td></tr>\n" .  
"<tr><td class=\"tblhead\">Document:</td><td class=\"tblcontent\"><input type=\"file\" name=\"File\"></td></tr>\n" .
"<tr><td></td><td><input type=\"hidden\" name=\"type\" value=\"doc\"><input type=\"submit\" value=\"Add Document\"></td></tr>\n" . 
"</tbody></table></form>";

}






function register_new_user()
{
if (check_user_priviliges_access("A") == "1")
{


if ($_GET['stat'] == 1)
{
echo "Saved!";
$genform = "No";
}

if ($_GET['stat'] == 2)
{
echo "An Error Occurred";
}

if ($genform != "No" )
{
// Add a record to the authtokens table
$idkey = mt_rand(100,999999999999);
$curruser = get_current_user_name();
db_insert_auth_token($curruser,$idkey,"","adduser");


include 'config/config.php';

echo "<form method=\"post\" action=\"$cryptoconnection/adminbackupproc.php\">\n" .
"<table><tbody>\n" .
"<tr><td class=\"tblhead\">Username:</td><td class=\"tblcontent\"><input type=\"text\" name=\"Username\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Display Name:</td><td class=\"tblcontent\"><input type=\"text\" name=\"DisplayName\"></td></tr>\n" .
"<tr><td class=\"tblhead\">E-Mail:</td><td class=\"tblcontent\"><input type=\"text\" name=\"Email\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Disabled:</td><td class=\"tblcontent\"><select name=\"Disabled\"><Option value=\"0\">No</option>" .
"<option value=\"1\">Yes</option></select></td></tr>\n" .
"<tr><td class=\"tblhead\">Moderator:</td><td class=\"tblcontent\"><select name=\"Moderator\"><Option value=\"0\">No</option>" .
"<option value=\"1\">Yes</option></select></td></tr>\n" .
"<tr><td class=\"tblhead\">Developer:</td><td class=\"tblcontent\"><select name=\"Developer\"><Option value=\"0\">No</option>" .
"<option value=\"1\">Yes</option></select></td></tr>\n" .
"<tr><td class=\"tblhead\">Administrator:</td><td class=\"tblcontent\"><select name=\"Admin\"><Option value=\"0\">No</option>" .
"<option value=\"1\">Yes</option></select></td></tr>\n" .
"<tr><td class=\"tblhead\">Password:</td><td class=\"tblcontent\"><input type=\"Password\" name=\"Password\"></td></tr>\n" .
"<tr><td class=\"tblhead\"><input type=\"hidden\" name=\"action\" value=\"newuserprocess\"></td><td class=\"tblcontent\"><input type=\"submit\" value=\"Add User\"></td></tr>\n" .
"<input type=\"hidden\" name=\"key\" value=\"$idkey\"><input type=\"hidden\" name=\"user\" value=\"$curruser\"></tbody></table></form>\n";
}
}
}

















function generate_user_login_form()
{
include 'config/config.php';
echo "<form method=\"post\" action=\"$cryptoconnection/logindo.php\">\n" .
"<table border=\"0\"><tbody>\n" .
"<tr><td class=\"tblhead\">Username:</td><td><input type=\"text\" name=\"User\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Password:</td><td><input type=\"password\" name=\"Pass\"></td></tr>\n" .
"<tr><td><input type=\"hidden\" name=\"action\" value=\"proc\"></td><td><input type=\"submit\" value=\"login\"></td></tr>\n" .
"</form></tbody></table>\n";


}




function generate_changelog_update_form()
{

$privset = check_user_priviliges_access("D");

if ($privset == 1)
{
// Grab the Project ID from the request URI

echo "<form method=\"post\" action=\"changelog.php\">\n" .
"<table border=\"0\"><tbody>\n" .
"<tr><td class=\"tblhead\">Project: </td><td>";

generate_project_dropdown('','',"N",'');

echo "</td></tr>\n" .
"<tr><td class=\"tblhead\">Date:</td><td><input type=\"text\" name=\"Date\" value=\"" . $date . "\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Change:</td><td><input type=\"text\" name=\"Change\"></td></tr>\n" .
"<tr><td><input type=\"hidden\" name=\"action\" value=\"process\"></td><td><input type=\"submit\" value=\"Save\"></td></tr>\n" . 
"</table>\n</form>\n" . output_BBcode_support();
}
}






function add_new_project_form()
{
$privset = check_user_priviliges_access("D");

if ($privset == 1)
{
echo "<form action=\"project.php\" method=\"post\"><table width=\"100%\"><tbody>\n" .
"<tr><td class=\"tblhead\">Project Name:</td><td><input type=\"text\" name=\"Project\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Start Date:</td><td><input type=\"text\" name=\"Date\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Project Description:</td><td><textarea name=\"ProjectDesc\"></textarea></td></tr>\n" .
"<tr><td class=\"tblhead\">Public:</td><td><input type=\"checkbox\" name=\"Public\" value=\"1\" checked></td></tr>\n" .
"<tr><td><input type=\"hidden\" name=\"action\" value=\"process\"></td><td><input type=\"submit\" value=\"Add Project\"></td></tr>\n" .

"</tbody></table></form>\n";

}
}




function edit_new_project_form()
{
$privset = check_user_priviliges_access("D");

if ($privset == 1)
{

if (empty($_GET['Project']))
{
$projectid = $_POST['Project'];

}
else
{
$projectid = $_GET['Project'];

}


// Print the Project selection box

echo '<script  type="text/javascript">' . "\n" .

"</script>\n\n" .
"<form action=\"project.php\" method=\"post\" name=\"selectproj\"><table width=\"100%\"><tbody>\n" .
"<tr><td class=\"tblhead\">Project:</td><td>";

generate_project_dropdown_JS("","","N","");

echo "<input type=\"hidden\" name=\"edit\" value=\"1\"><input type=\"submit\" value=\"Edit Project\"></td></tr>\n" .
"<tr><td colspan=\"2\"><hr></td></tr>\n" .
"</tbody></table>\n</form>\n";


// Print the edit page
$result = db_retrieve_project_details($projectid);

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

echo "<script type=\"text/javascript\">\n" .
"function validateprojeditForm()\n" . 
"{\n" .
"var del=document.forms[\"editproj\"][\"delete\"].checked\n" .
"if (del==true)\n" . 
"{\n" . 
"return confirm(\"Do you really want to delete this project?\")\n".
"  }\n" .
"}\n</script>".



"<form action=\"project.php\" method=\"post\" name=\"editproj\" onsubmit=\"return validateprojeditForm()\"><table width=\"100%\"><tbody>\n" .
"<tr><td class=\"tblhead\">Project Name:</td><td><input type=\"hidden\" name=\"Project\" value=\"{$row['ProjectRef']}\">" .
"<input type=\"text\" name=\"ProjectName\" value=\"{$row['ProjectName']}\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Start Date:</td><td><input type=\"text\" name=\"Date\" value=\"{$row['StartDate']}\"></td></tr>\n" .
"<tr><td class=\"tblhead\">Development Stopped:</td><td><input type=\"checkbox\" name=\"DevelStopped\" value=\"1\"";

if ($row['DevelopmentStopped'] == 1)
{
echo " checked";
}

echo "></td></tr>\n" .
"<tr><td class=\"tblhead\">Project Description:</td><td><textarea name=\"ProjectDesc\">{$row['ProjectDesc']}</textarea></td></tr>\n" .
"<tr><td class=\"tblhead\">Maintainer:</td><td>";

list_developer_users("","","N","",$row['Maintainer']);


echo "</td></tr>\n" .
"<tr><td class=\"tblhead\">Public:</td><td><input type=\"checkbox\" name=\"Public\" value=\"1\"";

if ($row['Public'] == 1)
{
echo " checked";
}

echo "></td></tr>\n" .
"<tr></tr>\n" .
"<tr><td class=\"tblhead\"><font color=\"red\">Delete Project:</font></td><td><input type=\"checkbox\" name=\"delete\" value=\"1\"></td></tr>\n" .
"<tr><td><input type=\"hidden\" name=\"action\" value=\"processedit\">" .
"<input type=\"hidden\" name=\"edit\" value=\"1\"></td><td><input type=\"submit\" value=\"Save\"></td></tr>\n" .

"</tbody></table></form>\n";
}
}
}


function report_bug_form()
{
$curuser = get_current_user_name();
if (!empty($curuser))
{

echo "<form action=\"reportbug.php\" method=\"POST\">\n" . 
"<table><tbody>\n" . 
"<tr><td class=\"tblhead\">Project</td><td>";
generate_project_dropdown("","","N","");
echo "</td></tr>\n"; 




echo "<tr><td class=\"tblhead\">Description:</td><td><textarea name=\"BriefDesc\"></textarea Cols=\"60\" rows=\"20\"></td></tr>\n" . 
"<tr><td class=\"tblhead\">2 + 2 =</td><td><input name=\"ans\" type=\"text\"></td></tr>\n" .
"<tr><td><input type=\"hidden\" name=\"action\" value=\"process\"></td><td><input type=\"submit\" value=\"Report\"></td></tr>" .
"</tbody></table></form>\n";
}
}


function add_new_task_form()
{

$privset = check_user_priviliges_access("D");

if ($privset == 1)
{

echo "<form action=\"tasks.php\" method=\"post\"><table width=\"100%\"><tbody>\n" .
"<tr class=\"tblhead\"><td>";


if ((empty($_GET['Project'])) && (empty($_POST['Project'])))
{
echo "Project</td>"; 
}

echo "<td>Date</td><td>Task</td><td></td></tr>\n<tr class=\"tblcontent\" style=\"text-align: center;\"><td>";

if ((empty($_GET['Project'])) && (empty($_POST['Project'])))
{
generate_project_dropdown("","","N","");
}
else
{

if (empty($_GET['Project']))
{
$project = $_POST['Project'];
}
else
{
$project = $_GET['Project'];
}
echo "<input type=\"hidden\" name=\"Project\" value=\"" . $project ."\">";

}

echo "</td><td><input type=\"text\" name=\"Date\" value=\"" . $date . "\"></td>".
"<td><input type=\"hidden\" name=\"action\" value=\"process\"><input type=\"text\" name=\"Task\"></td>" .
"<td><input type=\"submit\" value=\"Add\"></td></tr>\n" .
"</tbody></table>";
}

}





function devel_display_bug_information($row)
{
// Display the information for a specific bug

echo "\n\n\n <!-- Bug Information - Developer View -->" .
"\n\n<form name=\"buginfo\" action=\"viewbug.php?BUGID={$row['BugRef']}\" method=\"post\">\n" .
"<table width=\"100%\"><tbody><input type=\"hidden\" name=\"action\" value=\"process\">";



$Desc = urldecode($row['BriefDesc']);
$DevNotes = urldecode($row['DeveloperNotes']);

echo "\n<tr><td class=\"tblhead\">Bug Status:</td><td class=\"tblcontent\"><select name=\"bugstat\" id=\"bugstat\">";

echo "<option value=\"O\"";
if ($row['Bugstatus'] == "O" )
{
echo " selected";
}
echo ">Open - Unassigned</option>";


echo "<option value=\"Y\"";
if (($row['Bugstatus'] == "Y" ) || ($row['Bugstatus'] == "C" ))
{
echo " selected";
}
echo ">Closed - Resolved</option>";

echo "<option value=\"S\"";
if ($row['Bugstatus'] == "S" )
{
echo " selected";
}
echo ">Suspended</option>";

echo "<option value=\"T\"";
if ($row['Bugstatus'] == "T" )
{
echo " selected";
}
echo ">Suspended - Sent for Testing</option>";

echo "<option value=\"A\"";
if ($row['Bugstatus'] == "A")
{
echo " selected";
}
echo ">Open - Assigned to Developer</option>";


echo "</select></td></tr>\n" .
"<tr><td class=\"tblhead\">Bug ID</td><td class=\"tblcontent\"><input type=\"hidden\" name=\"BugRef\" value=\"{$row['BugRef']}\">{$row['BugRef']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Date Logged</td><td class=\"tblcontent\">{$row['Datelogged']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Logged By</td><td class=\"tblcontent\">{$row['Loggedby']}</td></tr>\n" .
"<tr><td class=\"tblhead\">Details</td><td class=\"tblcontent\"><textarea name=\"Desc\">$Desc</textarea></td></tr>\n" .
"<tr><td class=\"tblhead\">Developer</td><td class=\"tblcontent\">";

list_developer_users("","","N","",$row['AssignedTo']);

echo "</td></tr>\n" .
"<tr><td></td></tr>\n".
"<tr><td class=\"tblhead\">Developer Notes</td><td class=\"tblcontent\"><textarea name=\"DevelNotes\">{$row['DeveloperNotes']}</textarea></td><td>";
output_BBcode_support();
echo "</td></tr>\n" . 
"<tr></tr>\n" .
"<tr><td></td><td><input type=\"submit\" value=\"Update\"></td></tr>\n" .
"</form>\n\n".
"<tr></tr>\n" .
"<tr><form action=\"viewbug.php\" method=\"post\" onsubmit=\"return DeletebugForm()\"><input type=\"hidden\" name=\"action\" value=\"delete\">" .
"<td><input type=\"hidden\" name=\"bugid\" value=\"{$row['BugRef']}\"><input type=\"submit\" value=\"Delete Bug\"></form></td><td></td></tr>";




echo "</tbody></table>\n\n\n<br><hr>\n <!-- Bug Information Ends -->\n\n\n";
close_db();

echo "\n<center>\n<table border=\"0\" width=\"85%\">\n<tr><td class=\"commentwrapper\">";
display_bug_comments($row['BugRef']);
echo "\n <center> \n";
generate_comment_form($row['BugRef'], $row['Project']);
echo "\n</center>\n</td></tr>\n</table>\n</center>\n";

}



function generate_comment_form($bugref, $project)
{
$curuser = get_current_user_name();
if ((!empty($curuser)) && (!empty($bugref)) && (!empty($project)))
{

$DisplayName = get_user_displayname($curuser);

echo "\n\n\n<!-- Add New Comment -->\n<h3>Add Comment</h3>\n\n" .
"<form action=\"comment.php\" method=\"post\">\n\n" .
"<table border=\"0\" width=\"40%\">\n<tbody>\n" .
"<input type=\"hidden\" name=\"BugRef\" value=\"$bugref\">\n" .
"<input type=\"hidden\" name=\"Project\" value=\"$project\">\n" .
"<input type=\"hidden\" name=\"action\" value=\"process\">\n" .
"<tr><td><b>Name:</b></td><td><input type=\"text\" name=\"DisplayName\" value=\"$DisplayName\"></td></tr>\n" .
"<tr><td><b>Comment:</b></td>" .
"<td><textarea name=\"Comment\">Enter your comment, no HTML allowed</textarea></td><td>";

output_BBcode_support();

echo "</td></tr>\n" .
"<tr><td></td><td></td></tr>\n" .
"<tr><td></td><td><input type=\"submit\" value=\"Comment\"></td></tr>\n" .
"</tbody>\n</table>\n\n" . 
"</form>\n<!-- Add New Comment Ends -->\n\n\n";

}
}


?>
