<?php 
/**
* This file is part of the BUGGER Library 
*
* Copyright (C) 2011 B Tasker
* License: GPLV3, see LICENSE
*/

include_once 'lib/db/retrieve.php';


function ReturnExtractedString($str, $start, $end)
{
$pos_start = strpos($str, $start);
if ($pos_start === false)
{
return $str;
}


$pos_end = strpos($str, $end, ($pos_start + strlen($start)));


if ( ($pos_start !== false) && ($pos_end !== false) )
{
$pos1 = $pos_start + strlen($start);
$pos2 = $pos_end - $pos1;
return substr($str, $pos1, $pos2);
}
}


function implement_bb_code($text,$prefix = 'N',$newwin = "N")
{

// Check for value of [bug]



$BUGID = ReturnExtractedString($text, "[bug]", "[/bug]");

if ($newwin == "Y")
{
$target = "target=\"_blank\"";
}

if ($prefix == "Y")
{
$link = "http://" . $_SERVER['HTTP_HOST'] . "/";
}


if ((!empty($BUGID)) && (is_numeric($BUGID)))
{
$text = str_replace("[bug]","<a href=\"$link" . "viewbug.php?BUGID=$BUGID\" $target>BUG ",$text);
$text = str_replace("[/bug]","</a>",$text);
}
return $text;
}


function translate_release_type_code($code)
{
/*
<select name=\"Patch\"><option value=\"0\">Full Release</option>" . 
"<option value=\"1\">Patch Release</option></select>
*/

if ($code == "0")
{
echo "Full Release";
}

if ($code == "1")
{
echo "Patch Release";
}

}


function translate_file_sec_codes($code)
{

/*
option value=\"U\">Public</option>" .
"<option value=\"R\">Registered</option><option value=\"D\">Developers</option><option value=\"A\">Administrators</option>
*/

if ($code == "U")
{
echo "<font color=\"green\">Unrestricted - Available to all</font>";
}


if ($code == "R")
{
echo "<font color=\"red\">Restricted - Available to Registered Users Only</font>";
}


if ($code == "D")
{
echo "<font color=\"red\">Restricted - Available to Developers and Above Only</font>";
}


if ($code == "A")
{
echo "<font color=\"red\">Restricted - Available to Administrators Only</font>";
}



}



function translate_license_code($code)
{


$result = db_retrieve_license_name($code);

echo "<script type=\"text/javascript\">\n" . 
"function LaunchPopupLicense(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=800,width=600,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n";


while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{
echo "<a href=\"Javascript:LaunchPopupLicense('License.php?ref=$code');\">{$row['LicenseName']}</a>";


}





}


?>
