<?php
/**
* This file is part of the BUGGER Library 
*
* Copyright (C) 2011 B Tasker
* License: GPLV3, see LICENSE
*/

include_once 'lib/db/db_basics.php';

// Retrieve non-authentication data about the username
function db_retrieve_user_info($username)
{
open_db();
$query = "SELECT DisplayName, EMail, Disabled, Moderator, Developer, Admin, LastUpdatedBy, LastUpdated FROM Users where UserName = '" . $username ."'";
$result = mysql_query($query);

return $result;

}


function db_retrieve_backup_pass()
{
open_db();

$query = "SELECT BackupPass, BackupSalt1, BackupSalt2 from Config WHERE Keyfield = '1'";
$queryresult = mysql_query($query);

$result = mysql_fetch_array($queryresult,MYSQL_ASSOC);

close_db();

return $result;



}


function db_retrieve_footer()
{
open_db();
$query = "SELECT Footertext from Config WHERE Keyfield = '1'";
$result = mysql_query($query);

return $result;

}


function db_retrieve_user_salt($username)
{
open_db();
$username = make_string_safe($username);

$query = "SELECT S1,S2 from Users where Username = '" . $username ."'";
$result = mysql_query($query);
return $result;
}

function db_retrieve_user_login_dets($username)
{
open_db();
$username = make_string_safe($username);

$query = "SELECT UserName, Password, DisplayName from Users where Username = '". $username ."'";
$result = mysql_query($query);
return $result;


}


function db_retrieve_projects()
{
open_db();
$query = "SELECT ProjectRef, ProjectName, DevelopmentStopped FROM Projects WHERE Public='1' ORDER BY DevelopmentStopped, ProjectName";
$result = mysql_query($query);

return $result;



}

function db_retrieve_projects_nonpublic()
{
open_db();
$query = "SELECT ProjectRef, ProjectName,DevelopmentStopped,Public FROM Projects ORDER BY DevelopmentStopped, ProjectName";
$result = mysql_query($query);

return $result;



}


function db_retrieve_releases($project,$retfiles)
{
open_db();
$project = make_string_safe($project);

if ($retfiles == "N" )
{
$query = "SELECT ReleaseRef, MD5, Version, Security, FileName, FileSize FROM Releases Where Project = '" . $project . "' ORDER BY ReleaseRef DESC";
}
else
{
$query = "SELECT * FROM Releases Where Project = '" . $project . "' ORDER BY ReleaseRef";
}
$result = mysql_query($query);
return $result;

}

function db_retrieve_full_release_info($release)
{
open_db();
$release = make_string_safe($release);

$query = "SELECT ReleaseRef, Project, Patch, Version, Security, User, RegisteredDate, License, MD5, FileName, FileSize, MIMEType, Notes FROM Releases Where ReleaseRef = '" . $release . "'";
$result = mysql_query($query);
return $result;

}

function db_retrieve_full_document_info($document)
{
open_db();
$document = make_string_safe($document);

$query = "SELECT DocumentRef, Project, Title, Version, Description, Security, User, RegisteredDate, FileName, FileSize, MIMEType, License FROM Documents Where DocumentRef = '" . $document . "'";
$result = mysql_query($query);
return $result;

}


function db_retrieve_documents($project,$retfiles)
{
open_db();
$project = make_string_safe($project);

if ($retfiles == "N" )
{
$query = "SELECT DocumentRef, Title, Version, Security, RegisteredDate, FileName, FileSize FROM Documents Where Project = '" . $project . "' ORDER BY DocumentRef DESC";
}
else
{
$query = "SELECT * FROM Documents Where Project = '" . $project . "'";
}
$result = mysql_query($query);
return $result;

}










function db_retrieve_licenses($retrievetext)
{
open_db(); 

if ($retrievetext == "Y" )
{
$query = "SELECT * FROM Licenses";

}
else
{
$query = "SELECT LicenseRef, LicenseName FROM Licenses";
}
$result = mysql_query($query);
return $result;

}


function db_retrieve_license_name($licenseref)
{
open_db();
$licenseref = make_string_safe($licenseref);

$query = "Select * FROM Licenses Where LicenseRef = '" . $licenseref . "'";
$result = mysql_query($query);
return $result;

}



// Retrieve information on a specific bug
function retrieve_bug_info($bugid)
{
open_db();

$bugid = make_string_safe($bugid);

$query = "Select * from Bugs where BugRef = '" . $bugid . "'";
$result = mysql_query($query);
return $result;

}


function db_retrieve_bug_comments($bugid)
{
open_db();
$bugid = make_string_safe($bugid);

$query = "Select * from Comments where BugRef = '" . $bugid . "' ORDER BY CommentRef";

$result = mysql_query($query);
return $result;

}


// Retrieve bugs for a project
function retrieve_bugs_for_project($projectid,$bugtypes)
{
// bugtypes = A for All
// C = Closed bugs only
// O = Open Bugs only
// S = Suspended Bugs only
open_db();
$projectid = make_string_safe($projectid);

if ($bugtypes == "A")
{
$query = "Select * from Bugs where Project ='" . $projectid . "' ORDER BY BugRef DESC";
}






$result = mysql_query($query);

return $result;


}


function db_get_project_name($projectid)
{
open_db();
$projectid = make_string_safe($projectid);

$query = "Select ProjectName from Projects where ProjectRef = '" . $projectid . "'";
$result = mysql_query($query);
return $result;

}


function db_retrieve_developers()
{

open_db();

$query = "Select Username, DisplayName FROM Users WHERE Developer='1'";
$result = mysql_query($query);
return $result;

}


// Retrieve all details stored for the given project
function db_retrieve_project_details($projectid)
{

open_db();

$projectid = make_string_safe($projectid);

$query = "Select * from Projects where ProjectRef = '" . $projectid . "'";
$result = mysql_query($query);
return $result;


}



function db_retrieve_bug_stats($all,$status,$project)
{
open_db();

$status = make_string_safe($status);
$project = make_string_safe($project);

if ($all == "Y")
{
$query = "Select COUNT(Bugstatus) from Bugs WHERE Project = '" . $project . "'";
}

else
{
$status = mysql_real_escape_string($status);
$query = "Select COUNT(Bugstatus) from Bugs where Bugstatus = '" . $status ."' AND Project ='" . $project . "'";

}
$result = mysql_query($query);

while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{
close_db();
return $row['COUNT(Bugstatus)'];
}


}


function db_retrieve_project_changelog($project)
{
open_db();
$project = make_string_safe($project);
$query = "SELECT * FROM Changelog WHERE Project = '" . $project ."'";
$result = mysql_query($query);
return $result;



}


function db_retrieve_project_changelog_desc($project)
{
open_db();
$project = make_string_safe($project);
$query = "SELECT * FROM Changelog WHERE Project = '" . $project ."' ORDER BY ChangeRef DESC";
$result = mysql_query($query);
return $result;



}


function db_retrieve_tasks_full($project,$reverse)
{
open_db();
$project = make_string_safe($project);
$query = "SELECT * FROM Tasks WHERE Project = '" . $project ."' AND Completed = '0'";

if ($reverse == "Y")
{
$query = $query . " ORDER BY TaskRef DESC";

}


$result = mysql_query($query);
return $result;


}

function db_validate_user_auth_token($idkey,$username,$action)
{
open_db();
$idkey = make_string_safe($idkey);
$username = make_string_safe($username);
$action = make_string_safe($action);

$query = "SELECT * FROM Authtable WHERE idkey='" . $idkey ."' AND username='" . $username ."' AND action='" . $action ."'";
$result = mysql_query($query);


while($row = mysql_fetch_array($result, MYSQL_ASSOC))
{

if (($row['idkey'] == $idkey) && ($row['username'] == $username))
{
$resultret['auth'] = "1";
$resultret['DisplayName'] = $row['displayname'];
$resultret['UserName'] = $row['username'];

$query2 = "DELETE FROM Authtable WHERE rowid='" . $row['rowid'] . "'";
mysql_query($query2);
}
}

close_db();
return $resultret;

}

function db_retrieve_config()
{
open_db();
$query = "SELECT * FROM Config";
$result = mysql_query($query);
return $result;
}


?>
