<?php
/**
* This file is part of the BUGGER Library 
*
* Copyright (C) 2011 B Tasker
* License: GPLV3, see LICENSE
*/

include_once 'lib/auth.php';
include_once 'lib/db/retrieve.php';
include_once 'lib/form_generation.php';

function generate_navbar_menu()
{

$suffix = 4;
echo "<form method=\"GET\" name=\"navimenuprojtoggle\">\n" .
"<input type=\"hidden\" name=\"Project\" value=\"{$_GET['Project']}\">\n" .
"<input type=\"hidden\" name=\"BUGID\" value=\"{$_GET['BUGID']}\">\n";




if (isset($_GET['MenuProject']))
{
$suffix = $_GET['MenuProject'];
}else{
if (isset($_GET['Project'])){
$suffix = $_GET['Project'];
$_GET['MenuProject'] = $_GET['Project'];
}
}

generate_project_dropdown("","","N","","MenuProject","submitMenuForm()","menuSelection");

?>
</form>
<table width="100%" cellspacing="0" class="defaultmenutable">

<tr><td class="navbarmenuhead">Navigation</td></tr>
<tr><td class="navbarmenu">
<?php

echo "<a class=\"navlink\" href=\"index.php\">Home</a><br />\n".
"<a class=\"navlink\" href=\"projsummary.php?Project=$suffix\">Project Summary</a><br />\n".
"<a class=\"navlink\" href=\"buglist.php?Project=$suffix\">Bugs</a><br />\n" .
"<a class=\"navlink\" href=\"relview.php?Project=$suffix\">Releases</a><br />\n" .
"<a class=\"navlink\" href=\"docview.php?Project=$suffix\">Documents</a><br />\n".
"<a class=\"navlink\" href=\"Javascript: LaunchPopupprojchangelog('changelogview.php?Project=$suffix');\">Changelog</a><br />\n" .
"<a class=\"navlink\" href=\"JavaScript: LaunchPopupTask('tasks.php?Project=$suffix');\">Tasks</a><br />\n";



?>

</td></tr></table>
<?php

}





function display_page_footer()
{
$result = db_retrieve_footer();

$text = mysql_fetch_array($result, MYSQL_ASSOC);

echo $text['Footertext'];

}


function report_bug_menu()
{

include 'config/display.php';
$curruser = get_current_user_name();
if (($display['Bugs'] == 1) && (!empty($curruser)))
{

echo "<script type=\"text/javascript\">\n" . 
"function LaunchPopupbugreport(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=450,width=800,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n\n";

//echo "<a href=\"Javascript: LaunchPopupbugreport('reportbug.php');\">Report Bug</a>\n";
echo "<form onsubmit=\"LaunchPopupbugreport('reportbug.php')\"><input type=\"submit\" value=\"Report Bug\"></form>";
}
}


function print_devel_menu()
{
$authval = check_user_priviliges_access("D");

if ($authval == 1)
{

echo "<center><b><u>Developer Menu</b></u></center><br /><br />";

echo "<script type=\"text/javascript\">\n" . 
"function LaunchPopupdevel(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=450,width=800,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n\n";





echo "<table width=\"100%\"><tbody style=\"text-align: center;\">\n<tr >";
include 'config/display.php';
if ($display['Releases'] == 1)
{
echo "<td><a href=\"Javascript: LaunchPopupdevel('addrel.php');\">Register Release</a></td>";
}

if ($display['Documents'] == 1)
{
echo "<td><a href=\"Javascript: LaunchPopupdevel('adddoc.php');\">Register Document</a></td>";
}


if ($display['Changelog'] == 1)
{
echo "<td><a href=\"Javascript: LaunchPopupdevel('changelog.php');\">Update Changelog</a></td>";
}

if ($display['Tasks'] == 1)
{
echo "<td><a href=\"Javascript: LaunchPopupdevel('tasks.php');\">Add Task</a></td>";
}

echo "</tr>\n<tr></tr><tr>";

echo "<td><a href=\"Javascript: LaunchPopupdevel('project.php');\">Add Project</a></td>";

echo "</td><td> <a href=\"Javascript: LaunchPopupdevel('project.php?edit=1');\">Edit Project</a></td>";


echo "<td></td>";

echo "</tr></tbody></table><br /><hr>";

}
}


function print_admin_menu()
{
$authval = check_user_priviliges_access("A");

if ($authval == 1)
{
echo "<table border=\"0\"><tbody>\n<tr><td><a href=\"admin_panel.php\">Settings</a></td><td></td><td></td><td></td></tr>\n</tbody></table>";
}
}


function display_admin_menu()
{
echo "<script type=\"text/javascript\">\n" . 
"function LaunchPopupadmin(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=400,width=400,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n\n" .
"<ul>\n".
"<li><a href=\"Javascript: LaunchPopupadmin('adduser.php');\">Add User</a></li><br />" .
"<li><a href=\"Javascript: LaunchPopupadmin('admin.php?action=setdisp');\">Update Display Settings</a></li><br />".
"<li><a href=\"Javascript: LaunchPopupadmin('admin.php?action=backuppass');\">Set Backup Retrieval Password</a></li><br />" .
"<li><a href=\"Javascript: LaunchPopupadmin('backup.php?action=user');\">Download Database Backup</a></li><br />" .
"</ul>\n\n\n";



}


function print_login_menu()
{


echo "<script type=\"text/javascript\">\n" . 
"function LaunchPopuplogin(url) {\n" .
"popupWindow = window.open(\n " .
"url,'popUpWindow','height=400,width=300,left=10,top=10,resizable=yes,scrollbars=yes,toolbar=no,menubar=no,location=no,directories=no,status=yes')\n" .
"}\n " .
"</script>\n\n";

if ($_SESSION['loggedin'] != 1)
{
echo "<a class=\"login\" href=\"JavaScript:LaunchPopuplogin('login.php');\">Log-in</a>";
}
else
{
echo "<a class=\"login\" href=\"JavaScript:LaunchPopuplogin('logout.php');\">Log-Out</a>";
}

}

function bug_lookup_by_id()
{
include 'config/display.php';
if ($display['Bugs'] == 1)
{

echo '<form action="viewbug.php" method="GET">' . 
'Bug ID: <input type="text" name="BUGID"><input type="submit" value="Load Bug Report">' .
'</form>' . "\n\n";

}
}


function releases_title()
{
include 'config/display.php';
if ($display['Releases'] == 1)
{
echo "<h2><a name=\"Releases\">Releases</h2></a>";

}
}


function documents_title()
{
include 'config/display.php';
if ($display['Documents'] == 1)
{

echo '<h2><a name="Documents">Documents</h2></a>';

}
}

function project_stats_title()
{
include 'config/display.php';
if ($display['Bugs'] == 1)
{

echo '<h2><A name="stats">Project Stats</h2></a>';

}
}


function project_tasks_title()
{
include 'config/display.php';
if ($display['Tasks'] == 1)
{

echo '<h2><A name="tasks">Project Tasks</h2></a>';

}
}

function project_changelog_title()
{

include 'config/display.php';
if ($display['Tasks'] == 1)
{
echo '<h2><A name="changelog">Changelog</a></h2>';
}

}


function retrieve_bugs_menu()
{
include 'config/display.php';
if ($display['Bugs'] == 1)
{

generate_project_dropdown("Retrieve Bugs","buglist.php","Y",0);
}
}




function projsummary_menu()
{


include 'config/display.php';

echo "<ul>";

if ($display['Releases'] == 1)
{

echo '<li><a href="#Releases" class="projsummarylink">Releases</a></li>';
}

if ($display['Documents'] == 1)
{

echo '<li><a href="#Documents" class="projsummarylink">Documents</a></li>';
}

if ($display['Bugs'] == 1)
{
echo '<li><A href="#stats" class="projsummarylink">Project Statistics</a></li>';
}

if ($display['Changelog'] == 1)
{
echo "<li><a href=\"#changelog\" class=\"projsummarylink\">Changelog</a></li>";
}

if ($display['Tasks'] == 1)
{
echo "<li><a href=\"#tasks\" class=\"projsummarylink\">Tasks</a></li>";

}

echo "</ul>";

}

?>
